#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <alloc.h>
#include <conio.h>
#include <mem.h>

#include "mtypes.h"

#include "mdriver.h"


void NS_SetBPM(UBYTE BPM)
{
	UWORD rate=((1193182UL)*125/50)/BPM;

	outportb(0x43,0x30);
	outportb(0x40,rate&0xff);
	outportb(0x40,rate>>8);
}


static void interrupt (*oldclocktick)();


void interrupt NS_inter(void)
{
	if(md_tickhandler!=NULL) md_tickhandler();
	NS_SetBPM(md_bpm);
	outportb(0x20,0x20);
}


BOOL NS_IsThere(void)
{
	return 1;
}

BOOL NS_SampleLoad(FILE *fp,SAMPLEINFO *smp)
{
	return 1;
}


void NS_SampleUnload(SAMPLEINFO *smp)
{
}


BOOL NS_Init(void)
{
	return 1;
}

void NS_Exit(void)
{
}


void NS_PlayStart(void)
{
	oldclocktick=getvect(0x8);
	setvect(0x8,NS_inter);
}


void NS_PlayStop(void)
{
	setvect(0x8,oldclocktick);
	outportb(0x43,0x36);
	outportb(0x40,0);
	outportb(0x40,0);
}


DRIVER nosnddriver={
	NULL,
	"No Sound",
	"MikMod Nosound Driver v1.0 - (c) Creative Silence",
	NS_IsThere,
	NS_SampleLoad,
	NS_SampleUnload,
	NS_Init,
	NS_Exit,
	NS_PlayStart,
	NS_PlayStop
};
